SASIIndex (apache-cassandra API)
Date: 2018-02-14

org.apache.cassandra.index.sasi

## Class SASIIndex

- java.lang.Object
- - org.apache.cassandra.index.sasi.SASIIndex

- All Implemented Interfaces:
    Index, INotificationConsumer

      public class SASIIndex
      extends java.lang.Object
      implements Index, INotificationConsumer

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.cassandra.index.Index

      `Index.CollatedViewIndexBuildingSupport, Index.IndexBuildingSupport, Index.Indexer, Index.Searcher`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SASIIndex(ColumnFamilyStore baseCfs, IndexMetadata config)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AbstractType<?>` | `customExpressionValueType()` If the index supports custom search expressions using the SELECT * FROM table WHERE expr(index_name, expression) syntax, this method should return the expected type of the expression argument.
    `boolean` | `dependsOn(ColumnDefinition column)` Called to determine whether this index targets a specific column.
    `java.util.Optional<ColumnFamilyStore>` | `getBackingTable()` If the index implementation uses a local table to store its index data this method should return a handle to it.
    `java.util.concurrent.Callable<?>` | `getBlockingFlushTask()` Return a task which performs a blocking flush of the index's data to persistent storage.
    `Index.IndexBuildingSupport` | `getBuildTaskSupport()` Get an instance of a helper to provide tasks for building the index from a set of SSTable data.
    `long` | `getEstimatedResultRows()` Return an estimate of the number of results this index is expected to return for any given query that it can be used to answer.
    `SSTableFlushObserver` | `getFlushObserver(Descriptor descriptor, OperationType opType)` Get flush observer to observe partition/cell events generated by flushing SSTable (memtable flush or compaction).
    `ColumnIndex` | `getIndex()`
    `IndexMetadata` | `getIndexMetadata()` Returns the IndexMetadata which configures and defines the index instance.
    `java.util.concurrent.Callable<?>` | `getInitializationTask()` Return a task to perform any initialization work when a new index instance is created.
    `java.util.concurrent.Callable<?>` | `getInvalidateTask()` Return a task which invalidates the index, indicating it should no longer be considered usable.
    `java.util.concurrent.Callable<?>` | `getMetadataReloadTask(IndexMetadata indexMetadata)` Return a task to reload the internal metadata of an index.
    `RowFilter` | `getPostIndexQueryFilter(RowFilter filter)` Transform an initial RowFilter into the filter that will still need to applied to a set of Rows after the index has performed it's initial scan.
    `java.util.concurrent.Callable<?>` | `getTruncateTask(long truncatedAt)` Return a task to truncate the index with the specified truncation timestamp.
    `void` | `handleNotification(INotification notification, java.lang.Object sender)`
    `Index.Indexer` | `indexerFor(DecoratedKey key, PartitionColumns columns, int nowInSec, OpOrder.Group opGroup, IndexTransaction.Type transactionType)` Creates an new `Indexer` object for updates to a given partition.
    `boolean` | `indexes(PartitionColumns columns)`
    `protected static PerSSTableIndexWriter` | `newWriter(AbstractType<?> keyValidator, Descriptor descriptor, java.util.Map<ColumnDefinition,ColumnIndex> indexes, OperationType opType)`
    `java.util.function.BiFunction<PartitionIterator,ReadCommand,PartitionIterator>` | `postProcessorFor(ReadCommand command)` Return a function which performs post processing on the results of a partition range read command.
    `void` | `register(IndexRegistry registry)` An index must be registered in order to be able to either subscribe to update events on the base table and/or to provide Searcher functionality for reads.
    `Index.Searcher` | `searcherFor(ReadCommand command)` Factory method for query time search helper.
    `boolean` | `shouldBuildBlocking()` Return true if this index can be built or rebuilt when the index manager determines it is necessary.
    `boolean` | `supportsExpression(ColumnDefinition column, Operator operator)` Called to determine whether this index can provide a searcher to execute a query on the supplied column using the specified operator.
    `void` | `validate(PartitionUpdate update)` Called at write time to ensure that values present in the update are valid according to the rules of all registered indexes which will process it.
    `static java.util.Map<java.lang.String,java.lang.String>` | `validateOptions(java.util.Map<java.lang.String,java.lang.String> options, CFMetaData cfm)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.cassandra.index.Index

      `getPreJoinTask, validate`

- - ### Constructor Detail

    - #### SASIIndex

          public SASIIndex(ColumnFamilyStore baseCfs,
                           IndexMetadata config)

  - ### Method Detail

    - #### validateOptions

          public static java.util.Map<java.lang.String,java.lang.String> validateOptions(java.util.Map<java.lang.String,java.lang.String> options,
                                                                                         CFMetaData cfm)

    - #### register

          public void register(IndexRegistry registry)

      Description copied from interface: `Index`
      An index must be registered in order to be able to either subscribe to update events on the base table and/or to provide Searcher functionality for reads. The double dispatch involved here, where the Index actually performs its own registration by calling back to the supplied IndexRegistry's own registerIndex method, is to make the decision as to whether or not to register an index belong to the implementation, not the manager.
      Specified by:
        `register` in interface `Index`
      Parameters:
        `registry` - the index registry to register the instance with

    - #### getIndexMetadata

          public IndexMetadata getIndexMetadata()

      Description copied from interface: `Index`
      Returns the IndexMetadata which configures and defines the index instance. This should be the same object passed as the argument to setIndexMetadata.
      Specified by:
        `getIndexMetadata` in interface `Index`
      Returns:
        the index's metadata

    - #### getInitializationTask

          public java.util.concurrent.Callable<?> getInitializationTask()

      Description copied from interface: `Index`
      Return a task to perform any initialization work when a new index instance is created. This may involve costly operations such as (re)building the index, and is performed asynchronously by SecondaryIndexManager
      Specified by:
        `getInitializationTask` in interface `Index`
      Returns:
        a task to perform any necessary initialization work

    - #### getMetadataReloadTask

          public java.util.concurrent.Callable<?> getMetadataReloadTask(IndexMetadata indexMetadata)

      Description copied from interface: `Index`
      Return a task to reload the internal metadata of an index. Called when the base table metadata is modified or when the configuration of the Index is updated Implementations should return a task which performs any necessary work to be done due to updating the configuration(s) such as (re)building etc. This task is performed asynchronously by SecondaryIndexManager
      Specified by:
        `getMetadataReloadTask` in interface `Index`
      Returns:
        task to be executed by the index manager during a reload

    - #### getBlockingFlushTask

          public java.util.concurrent.Callable<?> getBlockingFlushTask()

      Description copied from interface: `Index`
      Return a task which performs a blocking flush of the index's data to persistent storage.
      Specified by:
        `getBlockingFlushTask` in interface `Index`
      Returns:
        task to be executed by the index manager to perform the flush.

    - #### getInvalidateTask

          public java.util.concurrent.Callable<?> getInvalidateTask()

      Description copied from interface: `Index`
      Return a task which invalidates the index, indicating it should no longer be considered usable. This should include an clean up and releasing of resources required when dropping an index.
      Specified by:
        `getInvalidateTask` in interface `Index`
      Returns:
        task to be executed by the index manager to invalidate the index.

    - #### getTruncateTask

          public java.util.concurrent.Callable<?> getTruncateTask(long truncatedAt)

      Description copied from interface: `Index`
      Return a task to truncate the index with the specified truncation timestamp. Called when the base table is truncated.
      Specified by:
        `getTruncateTask` in interface `Index`
      Parameters:
        `truncatedAt` - timestamp of the truncation operation. This will be the same timestamp used in the truncation of the base table.
      Returns:
        task to be executed by the index manager when the base table is truncated.

    - #### shouldBuildBlocking

          public boolean shouldBuildBlocking()

      Description copied from interface: `Index`
      Return true if this index can be built or rebuilt when the index manager determines it is necessary. Returning false enables the index implementation (or some other component) to control if and when SSTable data is incorporated into the index. This is called by SecondaryIndexManager in buildIndexBlocking, buildAllIndexesBlocking and rebuildIndexesBlocking where a return value of false causes the index to be exluded from the set of those which will process the SSTable data.
      Specified by:
        `shouldBuildBlocking` in interface `Index`
      Returns:
        if the index should be included in the set which processes SSTable data, false otherwise.

    - #### getBackingTable

          public java.util.Optional<ColumnFamilyStore> getBackingTable()

      Description copied from interface: `Index`
      If the index implementation uses a local table to store its index data this method should return a handle to it. If not, an empty Optional should be returned. Typically, this is useful for the built-in Index implementations.
      Specified by:
        `getBackingTable` in interface `Index`
      Returns:
        an Optional referencing the Index's backing storage table if it has one, or Optional.empty() if not.

    - #### indexes

          public boolean indexes(PartitionColumns columns)

    - #### dependsOn

          public boolean dependsOn(ColumnDefinition column)

      Description copied from interface: `Index`
      Called to determine whether this index targets a specific column. Used during schema operations such as when dropping or renaming a column, to check if the index will be affected by the change. Typically, if an index answers that it does depend upon a column, then schema operations on that column are not permitted until the index is dropped or altered.
      Specified by:
        `dependsOn` in interface `Index`
      Parameters:
        `column` - the column definition to check
      Returns:
        true if the index depends on the supplied column being present; false if the column may be safely dropped or modified without adversely affecting the index

    - #### supportsExpression

          public boolean supportsExpression(ColumnDefinition column,
                                            Operator operator)

      Description copied from interface: `Index`
      Called to determine whether this index can provide a searcher to execute a query on the supplied column using the specified operator. This forms part of the query validation done before a CQL select statement is executed.
      Specified by:
        `supportsExpression` in interface `Index`
      Parameters:
        `column` - the target column of a search query predicate
        `operator` - the operator of a search query predicate
      Returns:
        true if this index is capable of supporting such expressions, false otherwise

    - #### customExpressionValueType

          public AbstractType<?> customExpressionValueType()

      Description copied from interface: `Index`
      If the index supports custom search expressions using the SELECT * FROM table WHERE expr(index_name, expression) syntax, this method should return the expected type of the expression argument. For example, if the index supports custom expressions as Strings, calls to this method should return UTF8Type.instance. If the index implementation does not support custom expressions, then it should return null.
      Specified by:
        `customExpressionValueType` in interface `Index`
      Returns:
        an the type of custom index expressions supported by this index, or an null if custom expressions are not supported.

    - #### getPostIndexQueryFilter

          public RowFilter getPostIndexQueryFilter(RowFilter filter)

      Description copied from interface: `Index`
      Transform an initial RowFilter into the filter that will still need to applied to a set of Rows after the index has performed it's initial scan. Used in ReadCommand#executeLocal to reduce the amount of filtering performed on the results of the index query.
      Specified by:
        `getPostIndexQueryFilter` in interface `Index`
      Parameters:
        `filter` - the intial filter belonging to a ReadCommand
      Returns:
        the (hopefully) reduced filter that would still need to be applied after the index was used to narrow the initial result set

    - #### getEstimatedResultRows

          public long getEstimatedResultRows()

      Description copied from interface: `Index`
      Return an estimate of the number of results this index is expected to return for any given query that it can be used to answer. Used in conjunction with indexes() and supportsExpression() to determine the most selective index for a given ReadCommand. Additionally, this is also used by StorageProxy.estimateResultsPerRange to calculate the initial concurrency factor for range requests
      Specified by:
        `getEstimatedResultRows` in interface `Index`
      Returns:
        the estimated average number of results a Searcher may return for any given query

    - #### validate

          public void validate(PartitionUpdate update)
                        throws InvalidRequestException

      Description copied from interface: `Index`
      Called at write time to ensure that values present in the update are valid according to the rules of all registered indexes which will process it. The partition key as well as the clustering and cell values for each row in the update may be checked by index implementations
      Specified by:
        `validate` in interface `Index`
      Parameters:
        `update` - PartitionUpdate containing the values to be validated by registered Index implementations
      Throws:
        `InvalidRequestException`

    - #### indexerFor

          public Index.Indexer indexerFor(DecoratedKey key,
                                          PartitionColumns columns,
                                          int nowInSec,
                                          OpOrder.Group opGroup,
                                          IndexTransaction.Type transactionType)

      Description copied from interface: `Index`
      Creates an new `Indexer` object for updates to a given partition.
      Specified by:
        `indexerFor` in interface `Index`
      Parameters:
        `key` - key of the partition being modified
        `columns` - the regular and static columns the created indexer will have to deal with. This can be empty as an update might only contain partition, range and row deletions, but the indexer is guaranteed to not get any cells for a column that is not part of `columns`.
        `nowInSec` - current time of the update operation
        `opGroup` - operation group spanning the update operation
        `transactionType` - indicates what kind of update is being performed on the base data i.e. a write time insert/update/delete or the result of compaction
      Returns:
        the newly created indexer or `null` if the index is not interested by the update (this could be because the index doesn't care about that particular partition, doesn't care about that type of transaction, ...).

    - #### searcherFor

          public Index.Searcher searcherFor(ReadCommand command)
                                     throws InvalidRequestException

      Description copied from interface: `Index`
      Factory method for query time search helper.
      Specified by:
        `searcherFor` in interface `Index`
      Parameters:
        `command` - the read command being executed
      Returns:
        an Searcher with which to perform the supplied command
      Throws:
        `InvalidRequestException`

    - #### getFlushObserver

          public SSTableFlushObserver getFlushObserver(Descriptor descriptor,
                                                       OperationType opType)

      Description copied from interface: `Index`
      Get flush observer to observe partition/cell events generated by flushing SSTable (memtable flush or compaction).
      Specified by:
        `getFlushObserver` in interface `Index`
      Parameters:
        `descriptor` - The descriptor of the sstable observer is requested for.
        `opType` - The type of the operation which requests observer e.g. memtable flush or compaction.
      Returns:
        SSTable flush observer.

    - #### postProcessorFor

          public java.util.function.BiFunction<PartitionIterator,ReadCommand,PartitionIterator> postProcessorFor(ReadCommand command)

      Description copied from interface: `Index`
      Return a function which performs post processing on the results of a partition range read command. In future, this may be used as a generalized mechanism for transforming results on the coordinator prior to returning them to the caller. This is used on the coordinator during execution of a range command to perform post processing of merged results obtained from the necessary replicas. This is the only way in which results are transformed in this way but this may change over time as usage is generalized. See CASSANDRA-8717 for further discussion. The function takes a PartitionIterator of the results from the replicas which has already been collated and reconciled, along with the command being executed. It returns another PartitionIterator containing the results of the transformation (which may be the same as the input if the transformation is a no-op).
      Specified by:
        `postProcessorFor` in interface `Index`

    - #### getBuildTaskSupport

          public Index.IndexBuildingSupport getBuildTaskSupport()

      Description copied from interface: `Index`
      Get an instance of a helper to provide tasks for building the index from a set of SSTable data. When processing a number of indexes to be rebuilt, `SecondaryIndexManager.buildIndexesBlocking` groups those with the same `IndexBuildingSupport` instance, allowing multiple indexes to be built with a single pass through the data. The singleton instance returned from the default method implementation builds indexes using a `ReducingKeyIterator` to provide a collated view of the SSTable data.
      Specified by:
        `getBuildTaskSupport` in interface `Index`
      Returns:
        an instance of the index build taski helper. Index implementations which return the same instance will be built using a single task.

    - #### handleNotification

          public void handleNotification(INotification notification,
                                         java.lang.Object sender)

      Specified by:
        `handleNotification` in interface `INotificationConsumer`

    - #### getIndex

          public ColumnIndex getIndex()

    - #### newWriter

          protected static PerSSTableIndexWriter newWriter(AbstractType<?> keyValidator,
                                                           Descriptor descriptor,
                                                           java.util.Map<ColumnDefinition,ColumnIndex> indexes,
                                                           OperationType opType)

Copyright © 2018 The Apache Software Foundation